-- Useful math functions

function distancebetween(x1, y1, x2, y2)
  return math.sqrt(((x1-x2)^2)+((y1-y2)^2))
end

function boundangle(deg)
  while deg<0 or deg>=360 do
    if deg<0 then deg = deg + 360 end
    if deg>=360 then deg = deg - 360 end
  end
  return deg
end

function bearingtoangle(bearing)
  local angle = 90 - bearing
  angle = boundangle(angle)
  return angle
end

function angletobearing(angle)
  angle = math.deg(angle)
  angle = 90 - angle
  angle = boundangle(angle)
  return angle
end

function bearingtotext(bearing)
  local text = {"N", "NNE", "NE", "ENE", "E", "ESE", "SE", "SSE", "S", "SSW", "SW", "WSW", "W", "WNW", "NW", "NNW", "N"}
  bearing = math.floor((boundangle(bearing)/22.5)+0.5)+1
  return text[bearing]
end

function getanglediff(angle1, angle2)
  local d = math.abs(angle1-angle2)
  if 360-d<d then d=360-d end
  return d
end

function getbearingbetween(x1, y1, x2, y2)
  local angle = getanglebetween(x1, y1, x2, y2)
  return angletobearing(angle)
end

function getanglebetween(x1, y1, x2, y2)
  return math.atan2(y2-y1, x2-x1)
end

function inchestofeet(num)
  local feet, inches = 0, 0
  if num>0 then
    while num>=12 do
      feet = feet + 1
      num = num - 12
    end
    inches = num
  end
  if inches==0 then return feet.."ft"
  else return feet.."ft "..inches.."in" end
end

function poundstostones(num)
  local stones, pounds = 0, 0
  if num>0 then
    while num>=14 do
      stones = stones + 1
      num = num - 14
    end
    pounds = num
  end
  if pounds==0 then return stones.."st"
  else return stones.."st "..pounds.."lb" end
end