-------------------------------------------------------------------------------
--    Download an mp3 speech file from text, save it as lineX.mp3 (next)     --
-------------------------------------------------------------------------------

local http = require('socket.http')

local function urlencode(str)
  if (str) then
      str = string.gsub (str, "\n", "\r\n")
      str = string.gsub (str, "([^%w ])",
      function (c) return string.format ("%%%02X", string.byte(c)) end)
      str = string.gsub (str, " ", "+")
  end
  return str
end

local function download_file(string, filename)
  local file = love.filesystem.newFile(filename)
  file:open("w")
  http.request{
    url = "https://translate.google.com/translate_tts?ie=UTF-8&q=" .. urlencode(string) .. "&tl=en&client=tw-ob",
    headers = {
      "Referer: http://translate.google.com/",
      "User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:57.0) Gecko/20100101 Firefox/57.0"
    },
    sink = ltn12.sink.file(file)
  }
  file:close()
end

function create_speech(string)  -- Create speech file based upon string
  local contents, i
  contents = love.filesystem.getDirectoryItems("cache")
  i = 0
  if next(contents)~=nil then
    repeat
      i = i + 1
    until not love.filesystem.getInfo("cache/line"..i..".mp3")
  else i = 1 end
  download_file(string, "cache/line"..i..".mp3")
end